package model

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/mysql-story/src/db"
)

const (
	UID           = "uid"
	NAME          = "name"
	AVATAR        = "avatar"
	OPENID        = "openid"
	OPEN_ID       = "open_id"
	ADDRESS       = "address"
	USER_UID      = "user_uid"
	USER_NAME     = "user_name"
	PLACE_UID     = "place_uid"
	PLACE_ADDRESS = "place_address"
	STREET_UID    = "street_uid"
	STREET_NAME   = "street_name"
)

type Sess struct {
	db.ModelWithUID
	UserUID string `gorm:"type:char(32)"`
	IP      string `gorm:"type:char(16)"`
	Agent   string `gorm:"size:char(256)"`
}
type User struct {
	db.ModelWithUID
	OpenID string `gorm:"type:char(32)";index`
	Avatar string `gorm:"size:char(256)"`
	Name   string `gorm:"type:char(32)"`
	Email  string `gorm:"type:char(32)"`
}
type UserPlace struct {
	db.Model
	UserUID  string `gorm:"type:char(32);index"`
	PlaceUID string `gorm:"type:char(32)"`
}
type Place struct {
	db.ModelWithUID
	StreetUID string `gorm:"type:char(32)"`
	Address   string `gorm:"size:char(256)"`
}
type Street struct {
	db.ModelWithUID
	Name string `gorm:"type:char(32)"`
}

type models struct{ db.Models }

func (s models) Init(m *ice.Message, arg ...string) {
	s.Models.Register(m, "gonganxitong", &Sess{}, &User{}, &UserPlace{}, &Place{}, &Street{})
}

func init() { ice.Cmd("web.team.community.gonganxitong.models", models{}) }
